#include "Main.h"
#include "hw.h"   // histogram window
#include <cstdlib>
#include <iostream>       // std::cout
#include <string>         // std::string
#include <TGMsgBox.h>
#include <TMath.h>
#include <TF1.h>

ClassImp(HistWin)
HistWin::HistWin() 
{
}
extern int codepointer;  // int to hold location of execution of code
extern short int histwin1;
extern int run_no;
extern unsigned int *tracehist ;
char histtitle[80];
extern short int moduleNr; //the module nr we are looking at 
extern short int channelNr;//the channel nr we are looking at
extern unsigned short NumModulesg;  // global variable
extern bool module_data;   // TRUE if run in progress otherwise FALSE
extern long int updatecounter;
HistWin::HistWin(const TGWindow *p,UInt_t w,UInt_t h)   // ,char * filnam05,int run_no02 )
: TGMainFrame(p,w=1000,h=800)
{
p1 = p;
cout << "I am in HistWin constructor" << "\n" ;
cout << "before histwin1 = " << histwin1 << "\n" ;
histwin1++;
cout << "after histwin1 = " << histwin1 << "\n" ;

fHpx_waveMCA = NULL;
tracehist = NULL;
NumWords = 32768;
WindowHWmax = 9000;
WindowHWmin = 0 ;
   // main frame
/*   fMainFrame2926 = new TGMainFrame(this,10,10,kMainFrame | kVerticalFrame);
   fMainFrame2926->SetName("fMainFrame2926");
   fMainFrame2926->SetLayoutBroken(kFALSE);
*/
  // composite frame
   fMainFrame4041 = new TGCompositeFrame(this,1024,705,kVerticalFrame);
   fMainFrame4041->SetName("fMainFrame4041");

   // vertical frame
   fVerticalFrame770 = new TGVerticalFrame(fMainFrame4041,1024,703,kVerticalFrame);
   fVerticalFrame770->SetName("fVerticalFrame770");
   fVerticalFrame770->SetLayoutBroken(kTRUE);

   // embedded canvas
   fRootEmbeddedCanvas799 = new TRootEmbeddedCanvas(0,fVerticalFrame770,1016,576);
   fRootEmbeddedCanvas799->SetName("fRootEmbeddedCanvas799");
   Int_t wfRootEmbeddedCanvas799 = fRootEmbeddedCanvas799->GetCanvasWindowId();
   c124 = new TCanvas("c124", 10, 10, wfRootEmbeddedCanvas799);
   fRootEmbeddedCanvas799->AdoptCanvas(c124);
   fVerticalFrame770->AddFrame(fRootEmbeddedCanvas799, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fRootEmbeddedCanvas799->MoveResize(2,2,1016,540);
   TGFont *ufont;         // will reflect user font changes
//   ufont = gClient->GetFont("-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
ufont = gClient->GetFont("-*-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*");
   TGGC   *uGC;           // will reflect user GC changes
   // graphics context changes
   GCValues_t valEntry1814;
   valEntry1814.fMask = kGCForeground | kGCBackground | kGCFillStyle | kGCFont | kGCGraphicsExposures;
   gClient->GetColorByName("#000000",valEntry1814.fForeground);
   gClient->GetColorByName("#e0e0e0",valEntry1814.fBackground);
   valEntry1814.fFillStyle = kFillSolid;
   valEntry1814.fFont = ufont->GetFontHandle();
   valEntry1814.fGraphicsExposures = kFALSE;
   uGC = gClient->GetGC(&valEntry1814, kTRUE);
   fTextEntry1814 = new TGTextEntry(fVerticalFrame770, new TGTextBuffer(31),-1,uGC->GetGC(),ufont->GetFontStruct(),kSunkenFrame | kDoubleBorder | kOwnBackground);
   fTextEntry1814->SetMaxLength(4096);
   fTextEntry1814->SetAlignment(kTextLeft);
   fTextEntry1814->SetText("fTextEntry931");
   fTextEntry1814->Resize(808,fTextEntry1814->GetDefaultHeight());
   fVerticalFrame770->AddFrame(fTextEntry1814, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fTextEntry1814->MoveResize(200,592,730,22);
   fNumberEntry976 = new TGNumberEntry(fVerticalFrame770, (Int_t) 0,6, HCHAN_NO ,(TGNumberFormat::EStyle) 0,(TGNumberFormat::EAttribute) 1,(TGNumberFormat::ELimit) 2,0,15);
   fNumberEntry976->SetName("fNumberEntry976");
   fNumberEntry976->Associate(this);
   fVerticalFrame770->AddFrame(fNumberEntry976, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fNumberEntry976->MoveResize(960,624,48,22);

   ufont = gClient->GetFont("-*-helvetica-bold-r-*-*-14-*-*-*-*-*-*-*");

   // graphics context changes
   GCValues_t vall1819;
   vall1819.fMask = kGCForeground | kGCBackground | kGCFillStyle | kGCFont | kGCGraphicsExposures;
   gClient->GetColorByName("#000000",vall1819.fForeground);
   gClient->GetColorByName("#e0e0e0",vall1819.fBackground);
   vall1819.fFillStyle = kFillSolid;
   vall1819.fFont = ufont->GetFontHandle();
   vall1819.fGraphicsExposures = kFALSE;
   uGC = gClient->GetGC(&vall1819, kTRUE);
 
   ufont = gClient->GetFont("-*-helvetica-bold-r-*-*-17-*-*-*-*-*-*-*");

   // graphics context changes
   GCValues_t valButton1820;
   valButton1820.fMask = kGCForeground | kGCBackground | kGCFillStyle | kGCFont | kGCGraphicsExposures;
   gClient->GetColorByName("#000000",valButton1820.fForeground);
   gClient->GetColorByName("#e0e0e0",valButton1820.fBackground);
   valButton1820.fFillStyle = kFillSolid;
   valButton1820.fFont = ufont->GetFontHandle();
   valButton1820.fGraphicsExposures = kFALSE;
   uGC = gClient->GetGC(&valButton1820, kTRUE);

   ULong_t ucolor;        // will reflect user color changes
   gClient->GetColorByName("#99ff33",ucolor);

   ufont = gClient->GetFont("-*-helvetica-bold-r-*-*-14-*-*-*-*-*-*-*");

   // graphics context changes
   GCValues_t vall1825;
   vall1825.fMask = kGCForeground | kGCBackground | kGCFillStyle | kGCFont | kGCGraphicsExposures;
   gClient->GetColorByName("#000000",vall1825.fForeground);
   gClient->GetColorByName("#e0e0e0",vall1825.fBackground);
   vall1825.fFillStyle = kFillSolid;
   vall1825.fFont = ufont->GetFontHandle();
   vall1825.fGraphicsExposures = kFALSE;
   uGC = gClient->GetGC(&vall1825, kTRUE);
   fLabel1825 = new TGLabel(fVerticalFrame770,"Module No.:",uGC->GetGC(),ufont->GetFontStruct());
   fLabel1825->SetTextJustify(36);
   fLabel1825->SetMargins(0,0,0,0);
   fLabel1825->SetWrapLength(-1);
   fVerticalFrame770->AddFrame(fLabel1825, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fLabel1825->MoveResize(856,664,92,16);

   ufont = gClient->GetFont("-*-helvetica-bold-r-*-*-14-*-*-*-*-*-*-*");

   // graphics context changes
   GCValues_t valButton1826;
   valButton1826.fMask = kGCForeground | kGCBackground | kGCFillStyle | kGCFont | kGCGraphicsExposures;
   gClient->GetColorByName("#000000",valButton1826.fForeground);
   gClient->GetColorByName("#e0e0e0",valButton1826.fBackground);
   valButton1826.fFillStyle = kFillSolid;
   valButton1826.fFont = ufont->GetFontHandle();
   valButton1826.fGraphicsExposures = kFALSE;
   uGC = gClient->GetGC(&valButton1826, kTRUE);

   gClient->GetColorByName("#33ffff",ucolor);
   fTextButton1826 = new TGTextButton(fVerticalFrame770,"Refresh from Module",REFMCAFROM_MODULE,uGC->GetGC(),ufont->GetFontStruct());
   fTextButton1826->SetTextJustify(36);
   fTextButton1826->SetMargins(0,0,0,0);
   fTextButton1826->SetWrapLength(-1);
   fTextButton1826->Resize(192,56);

   fTextButton1826->ChangeBackground(ucolor);
   fTextButton1826->Associate(this);
   fVerticalFrame770->AddFrame(fTextButton1826, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fTextButton1826->MoveResize(640,624,192,56);

   gClient->GetColorByName("#3344ff",ucolor);
   fTextButton1827 = new TGTextButton(fVerticalFrame770,"Close",HW_CLOSE,uGC->GetGC(),ufont->GetFontStruct());
   fTextButton1827->SetTextJustify(36);
   fTextButton1827->SetMargins(0,0,0,0);
   fTextButton1827->SetWrapLength(-1);
   fTextButton1827->Resize(192,56);

   fTextButton1827->ChangeBackground(ucolor);
   fTextButton1827->Associate(this);
   fVerticalFrame770->AddFrame(fTextButton1827, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fTextButton1827->MoveResize(40,624,40,56);

   fPictureButton1683 = new TGPictureButton(fVerticalFrame770,gClient->GetPicture("ed_open.png"),HFOPICB);

   gClient->GetColorByName("#cccccc",ucolor);
   fPictureButton1683->ChangeBackground(ucolor);
   fPictureButton1683->Associate(this);
   fVerticalFrame770->AddFrame(fPictureButton1683, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fPictureButton1683->MoveResize(960,584,24,24);
//*********-----------------------------
ufont = gClient->GetFont("-*-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*");
   // graphics context changes
   GCValues_t valEntry957;
   valEntry957.fMask = kGCForeground | kGCBackground | kGCFillStyle | kGCFont | kGCGraphicsExposures;
   gClient->GetColorByName("#000000",valEntry957.fForeground);
   gClient->GetColorByName("#e0e0e0",valEntry957.fBackground);
   valEntry957.fFillStyle = kFillSolid;
   valEntry957.fFont = ufont->GetFontHandle();
   valEntry957.fGraphicsExposures = kFALSE;
   uGC = gClient->GetGC(&valEntry957, kTRUE);

   fNumberEntry979 = new TGNumberEntry(fVerticalFrame770, (Int_t) 0,10,HISTRUNNO,(TGNumberFormat::EStyle) 5);
   fNumberEntry979->SetName("fNumberEntry979");
   fNumberEntry979->Associate(this);
   fVerticalFrame770->AddFrame(fNumberEntry979, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fNumberEntry979->MoveResize(336,656,88,22);

   fNumberEntry979->SetIntNumber(run_no);  // update "Run number"

   ufont = gClient->GetFont("-*-helvetica-bold-r-*-*-14-*-*-*-*-*-*-*");

   // graphics context changes
   GCValues_t vall962;
   vall962.fMask = kGCForeground | kGCBackground | kGCFillStyle | kGCFont | kGCGraphicsExposures;
   gClient->GetColorByName("#000000",vall962.fForeground);
   gClient->GetColorByName("#e0e0e0",vall962.fBackground);
   vall962.fFillStyle = kFillSolid;
   vall962.fFont = ufont->GetFontHandle();
   vall962.fGraphicsExposures = kFALSE;
   uGC = gClient->GetGC(&vall962, kTRUE);
   TGLabel *fLabel962 = new TGLabel(fVerticalFrame770,"Base file name :",uGC->GetGC(),ufont->GetFontStruct());
   fLabel962->SetTextJustify(36);
   fLabel962->SetMargins(0,0,0,0);
   fLabel962->SetWrapLength(-1);
   fVerticalFrame770->AddFrame(fLabel962, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fLabel962->MoveResize(216,624,120,18);

   ufont = gClient->GetFont("-*-helvetica-bold-r-*-*-14-*-*-*-*-*-*-*");

   // graphics context changes
   GCValues_t vall963;
   vall963.fMask = kGCForeground | kGCBackground | kGCFillStyle | kGCFont | kGCGraphicsExposures;
   gClient->GetColorByName("#000000",vall963.fForeground);
   gClient->GetColorByName("#e0e0e0",vall963.fBackground);
   vall963.fFillStyle = kFillSolid;
   vall963.fFont = ufont->GetFontHandle();
   vall963.fGraphicsExposures = kFALSE;
   uGC = gClient->GetGC(&vall963, kTRUE);
   TGLabel *fLabel963 = new TGLabel(fVerticalFrame770,"Run number :",uGC->GetGC(),ufont->GetFontStruct());
   fLabel963->SetTextJustify(36);
   fLabel963->SetMargins(0,0,0,0);
   fLabel963->SetWrapLength(-1);
   fVerticalFrame770->AddFrame(fLabel963, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fLabel963->MoveResize(224,656,104,18);

   fHSlider1031 = new TGDoubleHSlider(fVerticalFrame770,1016, kScaleBoth ,-1,kHorizontalFrame); 
   fHSlider1031->SetName("fHSlider1031");
   fHSlider1031->SetRange(0,int (NumWords) );
   fHSlider1031->SetPosition(0,9000);
   fHSlider1031->Associate(this);
   fVerticalFrame770->AddFrame(fHSlider1031, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fHSlider1031->MoveResize(0,544,1016,24);

//**********---------------------------
   fMainFrame4041->AddFrame(fVerticalFrame770, new TGLayoutHints(kLHintsNormal));

//   fMainFrame2926->AddFrame(fMainFrame4041, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY));
   fMainFrame4041->MoveResize(0,0,1024,705);

/*   fMainFrame2926->SetMWMHints(kMWMDecorAll,
                        kMWMFuncAll,
                        kMWMInputModeless);
*/
   fMainFrame4041->MapSubwindows();

   fMainFrame4041->Resize(fMainFrame4041->GetDefaultSize());
   fMainFrame4041->MapWindow();
   fMainFrame4041->Resize(1072,707);

SetWindowName("Histogram Data window");
MapSubwindows();
Resize(1030,700);
MapWindow();               
}  // HistWin()


HistWin::~HistWin()
{
cout << "I am in HistWin destructor" << "\n" ;
cout << "before histwin1 = " << histwin1 << "\n" ;
histwin1 = 0 ;
cout << "after histwin1 = " << histwin1 << "\n" ;

if (fHpx_waveMCA)
    delete fHpx_waveMCA;

   SetCleanup(kDeepCleanup);
   Cleanup();

}// ~HistWin()

Bool_t HistWin::ProcessMessage (Long_t msg, Long_t parm1, Long_t parm2)
{
  switch (GET_MSG (msg))
    {
      case kC_COMMAND:
	switch (GET_SUBMSG (msg))
	  {
	    case kCM_BUTTON:
	      switch (parm1)
		{
		  case (REFMCAFROM_MODULE):
		    {
			load_datamodule(moduleNr , channelNr);  
		    }
		    break;
		  case (HW_CLOSE):
		    {
		    	cout << "I am here in CLOSE button pressed\n" ; 
		    	DeleteWindow ();
		    	// DestroyWindow();
		    }
		    break;
		  default:
		    break;
		}  // switch (parm1)
	      break;
	  
	    default:
	      break;
	  } // switch (GET_SUBMSG (msg))
	break;
      default:
	break;
    }  //  switch (GET_MSG (msg))
  return kTRUE;
} //  ProcessMessage ()

int HistWin::load_datamodule(unsigned short mod3333, unsigned short chan3333)
{
	unsigned int NumWords ;
	NumWords = 32768;
	char hname1[10] =  "MCA" ;

TF1 *fsin;


cout << "A\n";
fNumberEntry979->SetIntNumber(run_no);  // update "Run number"
cout << "C\n";
	if (tracehist == NULL)
		tracehist = new unsigned int[NumWords];
cout << "D\n";
	memset(tracehist, 0, NumWords * sizeof(unsigned int));
cout << "E\n";

//	generate histogram data and fill in tracehist.
// tracehist, NumWords

rand001 = rand001 + 1 ;
if (rand001 > 6  )
{ rand001 = 1 ; }

if (rand001 <= 0  )
{ rand001 = 1 ; }

Double_t x;

if ( rand001 == 1)
{  fsin = new TF1("fsin", "sin(x)+sin(2*x)+sin(0.5*x)+1", 0, 4*TMath::Pi());
   rand002= 1000;
}
else if ( rand001 == 2)
{  fsin = new TF1("fsin", "sin(x/2)+sin(2*x)+sin(0.5*x)+2", 0, 4*TMath::Pi());
   rand002= 2000;
}
else if ( rand001 == 3)
{  fsin = new TF1("fsin", "sin(x/3)+sin(2*x)+sin(0.5*x)+3", 0, 4*TMath::Pi());
   rand002= 3000;
}
else if ( rand001 == 4)
{  fsin = new TF1("fsin", "sin(x/4)+sin(2*x)+sin(0.5*x)+4", 0, 4*TMath::Pi());
   rand002= 4000;
}
else if ( rand001 == 5)
{  fsin = new TF1("fsin", "sin(x/5)+sin(2*x)+sin(0.5*x)+5", 0, 4*TMath::Pi());
   rand002= 5000;
}
else if ( rand001 == 6)
{  fsin = new TF1("fsin", "sin(x/6)+sin(2*x)+sin(0.5*x)+6", 0, 4*TMath::Pi());
   rand002= 6000;
}

for ( Int_t r = 0 ; r <= NumWords ; r++)
{
// Double_t value = 1/twoPi - TMath::Floor(r/twoPi) - 0.5;
x = (Double_t(r)/NumWords)*(4*TMath::Pi());
tracehist[r] = rand002 * fsin->Eval(x)   ;
// cout << "tracehist[r] = " << tracehist[r] << "\n" ;
}

//  cout << "Success - ReaddataFromModule (...)" << "\n";


char title01[20] = "data from module" ;
cout << "I am here 001" << "\n";
sprintf(histtitle,"%s,mod=%d,chan=%d", title01 ,mod3333, chan3333);
cout << "I am here 002" << "\n";
	if (fHpx_waveMCA == NULL ) {
			cout << "I am here 002bbbb" << "\n";
		 	fHpx_waveMCA = new TH1I ( hname1 , histtitle , NumWords, 0, NumWords ); // TH1I->SetAxisRange
		//	gStyle->SetOptStat(0);
			cout << "I am here 002cccc" << "\n";
			x_waveMCA = fHpx_waveMCA->GetXaxis();
			cout << "I am here 002eeee" << "\n";
				    }
	else { 	
		fHpx_waveMCA->SetTitle(histtitle); 
		cout << "I am here 00222" << "\n";  
	     }
cout << "I am here 003" << "\n";
	fHpx_waveMCA->UseCurrentStyle();
cout << "I am here 004" << "\n";

	fHpx_waveMCA->Reset();
cout << "I am here 006" << "\n";
	for ( int j = 0; j < NumWords ; j++)
		{  
		    fHpx_waveMCA->Fill(j, long (tracehist[j]) );
		}

cout << "I am here 006a" << "\n";
	xmaxdt = WindowHWmax;
	xmindt = WindowHWmin;
cout << "I am here 006b" << "\n";
	cout << "xmaxdt = " << xmaxdt << "\n";
	cout << "xmindt = " << xmindt << "\n";
cout << "I am here 006c" << "\n";
	fHpx_waveMCA->SetAxisRange(xmindt, xmaxdt, "X");
cout << "I am here 006d" << "\n";
	cout << "I am here 007" << "\n";
	c124->cd();
	cout << "I am here 008" << "\n";
	fHpx_waveMCA->DrawCopy();
//	fHpx_waveMCA->Draw();
	cout << "I am here 009" << "\n"; 

	c124->Modified();
	cout << "I am here 010" << "\n";
	c124->Update();
	cout << "I am here 011" << "\n";

return 1;
}  // int HistWin::load_datamodule(unsigned short mod3333, unsigned short chan3333)

