#ifndef HW_H_
#define HW_H_
#include "TGWindow.h"
#include "TGFrame.h"
#include "TGTextEntry.h"
#include "TGNumberEntry.h"
#include "TGLabel.h"
#include "TG3DLine.h"
#include <iostream>
#include "TRootEmbeddedCanvas.h"
#include "TAxis.h"
#include "TGSlider.h"
#include "TGDoubleSlider.h"

using namespace std;
	
class HistWin : public TGMainFrame
{
public:
HistWin();
HistWin(const TGWindow *p,UInt_t w,UInt_t h) ; // ,char * filnam05,int run_no02 );
	virtual ~HistWin();
	Bool_t ProcessMessage (Long_t msg, Long_t parm1, Long_t parm2);
	int load_datamodule(unsigned short mod444, unsigned short chan444);
TH1I *fHpx_waveMCA;
TAxis* x_waveMCA;
TAxis* y_waveMCA;
Int_t xmaxint_waveMCA;
Int_t xminint_waveMCA;
Double_t xmaxdt;
Double_t xmindt;
Double_t ymaxdt;
Double_t ymindt;
unsigned int NumWords ;
Int_t rand001, rand002;

  // composite frame
   TGCompositeFrame *fMainFrame4041;
   // vertical frame
   TGVerticalFrame *fVerticalFrame770;
   // embedded canvas
   TRootEmbeddedCanvas *fRootEmbeddedCanvas799;
   TCanvas *c124;
   TGLabel *fLabel1813;
   TGTextEntry *fTextEntry1814;
   TGLabel *fLabel1819;
   TGTextButton *fTextButton1820;
   TGNumberEntry *fNumberEntry976; // channel no
   TGNumberEntry *fNumberEntry1254; // Module no
   TGLabel *fLabel1825;
   TGTextButton *fTextButton1826;
   TGTextButton *fTextButton1827; // close button
   TGTextButton *exit;
   TGPictureButton *fPictureButton1683;
   TGTextBuffer *text103; 
   TGTextEntry *fTextEntry957;
   TGNumberEntry *fNumberEntry979;
  TGDoubleHSlider *fHSlider1031;
Float_t	WindowHWmax;
Float_t	WindowHWmin;

private:
const TGWindow *p1;

ClassDef(HistWin,0);
};

#endif /*HW_H_*/
